SystemOrganization addCategory: #'Ficonab-Public'!
SystemOrganization addCategory: #'Ficonab-Public-Tests'!

Object subclass: #EstormSES
	instanceVariableNames: 'client host port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ficonab-Public'!

!EstormSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/20/2011 20:17'!
buildClient
	client := ZnClient new.
	client host: self host.
	client port: self port..
	client	beOneShot.
	client timeout: 30.! !

!EstormSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/20/2011 20:11'!
client
client ifNil:[self buildClient.].
^client! !

!EstormSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/20/2011 20:16'!
credentials: anAccount password: password
self client setBasicAuthenticationUsername: anAccount password: password.! !

!EstormSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/20/2011 20:06'!
debug

self host: 'localhost'.
self port: 8083
! !

!EstormSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/20/2011 19:57'!
host
^host! !

!EstormSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/20/2011 20:04'!
host: aHost
host:=aHost.
^host! !

!EstormSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/20/2011 20:00'!
initialize

self host: 'ses.sg.estormtech.com'.
self port: 80.
! !

!EstormSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/20/2011 19:57'!
port
^port! !

!EstormSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/20/2011 20:00'!
port:aPort
port:=aPort.
^port! !

!EstormSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/20/2011 20:18'!
queryForBasicEmail
^'ficonabsendemail'! !

!EstormSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/20/2011 20:18'!
queryForBasicTemplate
^'ficonabsimpletemplate'! !

!EstormSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/20/2011 20:18'!
queryForParameterTemplate
^'ficonabcomplextemplate'! !

!EstormSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/21/2011 19:43'!
sendEmail: contents subject: aSubj destination: aDestination
	 self client	url: self queryForBasicEmail.	
		self client queryAt: 'text' put: contents; queryAt: 'destination' put:aDestination.
		self client queryAt: 'subject' put: aSubj.	
		self client get.
		
		^self client.! !

!EstormSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/21/2011 18:15'!
sendTemplate: atemplate destination: aDestination
	 self client	url: self queryForBasicTemplate.	
		self client queryAt: 'template' put: atemplate; queryAt: 'destination' put:aDestination.	
		self client get.
		
		^self client.! !

Object subclass: #FiconabCredentials
	instanceVariableNames: 'user password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ficonab-Public'!

!FiconabCredentials commentStamp: 'ScottSproule 5/11/2012 11:40' prior: 0!
A simple placehold to manage user and password.  Nothing complicated.!

!FiconabCredentials class methodsFor: 'as yet unclassified' stamp: 'ScottSproule 5/11/2012 11:40'!
descriptionPassword
 
 ^ MAStringDescription new
  selectorAccessor: #password;
  label: 'Clickatell user password';
  priority: 15;
  default: 'xxxxx';
  addCondition: [:value | (value ~= 'xxxxx')]
  labelled: 'Clicktell password invalid';
  yourself! !

!FiconabCredentials class methodsFor: 'as yet unclassified' stamp: 'ScottSproule 5/11/2012 11:40'!
descriptionUser
 
 ^ MAStringDescription new
  selectorAccessor: #user;
  label: 'Clickatel username';
  priority: 10;
  default: 'xxxxx';
  addCondition: [:value | (value ~= 'xxxxx')]
  labelled: 'Clickatel username invalid';
  yourself! !

!FiconabCredentials methodsFor: 'as yet unclassified' stamp: 'ScottSproule 5/10/2012 19:14'!
password
	
	^password! !

!FiconabCredentials methodsFor: 'as yet unclassified' stamp: 'ScottSproule 5/10/2012 19:14'!
password: aKey
	"comment stating purpose of message"
       password:=aKey.
	^password! !

!FiconabCredentials methodsFor: 'as yet unclassified' stamp: 'ScottSproule 5/10/2012 19:15'!
user
	"comment stating purpose of message"
 user ifNil: [self user: 'configure me'].
	^user! !

!FiconabCredentials methodsFor: 'as yet unclassified' stamp: 'ScottSproule 5/10/2012 19:15'!
user: aKey
	"comment stating purpose of message"
       user:=aKey.
	^user
	! !

Object subclass: #FiconabGsub
	instanceVariableNames: 'parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ficonab-Public'!

!FiconabGsub commentStamp: 'ScottSproule 11/17/2011 18:39' prior: 0!
A routine to do a replacement of keys from dictionary with values into a stream.

Similar to string.gsub in ruby

Instance Variables
	parameters:		<Object>

parameters
	- a Dictionary of parameters that you want replated
!

!FiconabGsub class methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/20/2011 00:21'!
httpReplace: aString using: aDict

| f tmpString |
tmpString:=aString.
aString ifNil: [tmpString:=' '. ].
f:= FiconabGsub new.
f httpParameters: aDict.
^f gsub: tmpString.! !

!FiconabGsub class methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/17/2011 18:53'!
replace: aString using: aDict

| f |
f:= FiconabGsub new.
f parameters: aDict.
^f gsub: aString.! !

!FiconabGsub methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/20/2011 19:42'!
gsub: aString
"from email correspondence with Nicolas Cellier "
| newString |
newString:= self parameters associations inject: aString into: [:subst :assoc | assoc
key asRegex copy: subst replacingMatchesWith: assoc value].
^newString! !

!FiconabGsub methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/18/2011 08:08'!
httpParameters: aDict
	"convert keys to {key}"
	
	
|newDictionary|
       newDictionary :=Dictionary new.
      aDict keysAndValuesDo: [:key :value| newDictionary at: '{',key,'}' put: value. ].
      ^self parameters: newDictionary.
	! !

!FiconabGsub methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/17/2011 18:58'!
initialize
	"comment stating purpose of message"
self parameters: Dictionary new.! !

!FiconabGsub methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/17/2011 18:35'!
parameters
	"comment stating purpose of message"

	^parameters! !

!FiconabGsub methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/17/2011 18:58'!
parameters: aDict
	"comment stating purpose of message"
      parameters:= aDict.
	^parameters! !

Object subclass: #FiconabSES
	instanceVariableNames: 'client host port credentials'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ficonab-Public'!

!FiconabSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 5/10/2012 19:06'!
buildClient
	 "Content-Type: application/json"
	         client := (ZnClient new)
			host: self host; 
		      port: self port.
		"UA::Config::app_key, UA::Config::push_secret"
			! !

!FiconabSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 5/10/2012 19:06'!
client
        client ifNil: [self buildClient].
	^client! !

!FiconabSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 5/10/2012 19:06'!
credentials
	^credentials! !

!FiconabSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 5/10/2012 19:06'!
credentials: aCred
	credentials:=aCred.
	^credentials! !

!FiconabSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 5/10/2012 19:06'!
host
	
^host! !

!FiconabSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 5/10/2012 19:06'!
host: aHost
	host:=aHost.
	 ^host! !

!FiconabSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 5/10/2012 19:08'!
initialize
	
	self host: 'ses.sg.estormtech.com'.
	self port: 80.! !

!FiconabSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 5/10/2012 19:06'!
port
	
	^port! !

!FiconabSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 5/10/2012 19:06'!
port: aPort
	port:=aPort.
	^port! !

!FiconabSES methodsFor: 'as yet unclassified' stamp: 'ScottSproule 5/11/2012 17:33'!
send: aDestination using: aTemplate with: parameters

 "http://#{@@host}/#{action}?destination=#{URI.encode(destination)}"
"#{self.action_url('ficonabcomplextemplate',destination)}&template=#{URI.encode(templatename)}&#{options.to_param}" 

	     self client
			path: '/ficonabcomplextemplate';
			 setBasicAuthenticationUsername: self credentials user  password: self credentials password;			
			headerAt: 'Host' put: 'ses.sg.estormtech.com'.
			self client queryAddAll:  parameters;
		   	queryAt: 'destination' put: aDestination;
			queryAt: 'template' put: aTemplate.		   
			self  client timeout: 25.     .
			self client get..
			^self client! !

TestCase subclass: #EstormSESTest
	instanceVariableNames: 'yourTsipid yourTemplateName yourAccount yourPassword yourEmail yourAPNTemplateName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ficonab-Public'!

!EstormSESTest methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/21/2011 18:48'!
setUp
	"comment stating purpose of message"

	
	
	yourEmail:='insertemail@here.com'.
	yourTsipid:='yourtsipid'.  "THIS is for Apple Push Notifications.  Do not worry about this to start with"
	yourTemplateName:='insertYourTemplateNameHere'.
	yourAPNTemplateName:='insertYourTemplateNameHere'.
	yourAccount:='insert your accountname'.  "from ses.sg.estormtech.com"
	yourPassword:='insertPassword'.
	! !

!EstormSESTest methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/20/2011 20:06'!
testBasicStuff
	"comment stating purpose of message"

	| temporary variable names tmp |
	
	tmp:=EstormSES new.
	self assert: tmp host='ses.sg.estormtech.com'.
	self assert: tmp port=80.
	tmp port: 81.
	self assert: tmp port=81.
	self deny: tmp port=80.
	tmp host: 'anewHost'.
	self assert: tmp host='anewHost'.
	tmp debug.
	self assert: tmp host= 'localhost'! !

!EstormSESTest methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/21/2011 18:48'!
testClientBasic
	"comment stating purpose of message"

	| temporary variable names tmp client res |
	
	client:=EstormSES new.
	client credentials: yourAccount password: yourPassword.
	res:=client sendTemplate: yourTemplateName destination: yourEmail.
	self assert: res isSuccess.
	self assert: (res response code=200).
	! !

!EstormSESTest methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/21/2011 18:49'!
testClientBasicAPN
	"comment stating purpose of message"

	| temporary variable names tmp client res |
	
	client:=EstormSES new.
	client credentials: yourAccount password: yourPassword.
	res:=client sendTemplate: yourAPNTemplateName destination: yourTsipid.
	self assert: res isSuccess.
	self assert: (res response code=200).
	! !

!EstormSESTest methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/21/2011 19:47'!
testClientEmail
	"comment stating purpose of message"

	| temporary variable names tmp client res |
	
	client:=EstormSES new.
	client credentials: yourAccount password: yourPassword.
	res:=client sendEmail: 'text email contents' subject: 'text email subject' destination: yourTsipid.
	self assert: res isSuccess.
	self assert: (res response code=200).
	self halt.
	! !

TestCase subclass: #FiconabGsubTests
	instanceVariableNames: 'parameters aDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ficonab-Public'!

!FiconabGsubTests methodsFor: 'as yet unclassified' stamp: 'ScottSproule 1/2/2012 08:31'!
setUp


	aDict:=Dictionary new.
	aDict at: 'test' put: 'testreplaced'; at: 'hello' put: 'hello'; at: 'hello2' put: 'hello2replaced'.
	aDict at: 'tsipid' put: '7923044488'.

	! !

!FiconabGsubTests methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/17/2011 19:08'!
testBasicEmpty

 | string result|
"aDict at: 'test' put: 'testreplaced'; at: 'hello' put: 'hello'; at: 'hello2' put: 'hello2replaced'."
     string:=''.
     result:= FiconabGsub replace: string using: aDict.
	self assert:  result=''.
	 string:='  '.
	 result:= FiconabGsub replace: string using: aDict.
	self assert: result='  '.
	
	
	! !

!FiconabGsubTests methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/17/2011 19:01'!
testBasicGsub

 | string result|
"aDict at: 'test' put: 'testreplaced'; at: 'hello' put: 'hello'; at: 'hello2' put: 'hello2replaced'."
     string:='test'.
     result:= FiconabGsub replace: string using: aDict.
	self assert:  result='testreplaced'.
	 string:='test test'.
	 result:= FiconabGsub replace: string using: aDict.
	self assert: result='testreplaced testreplaced'.
	
	
	! !

!FiconabGsubTests methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/17/2011 19:03'!
testBasicMoreComplexString

 | string result|
"aDict at: 'test' put: 'testreplaced'; at: 'hello' put: 'hello'; at: 'hello2' put: 'hello2replaced'."
     string:='hello'.
     result:= FiconabGsub replace: string using: aDict.
	self assert:  result='hello'.
	 string:='hello hello2'.
	 result:= FiconabGsub replace: string using: aDict.
	self assert: result='hello hello2replaced'.
	
	
	! !

!FiconabGsubTests methodsFor: 'as yet unclassified' stamp: 'ScottSproule 11/18/2011 08:10'!
testHttpReplace

 | string result|
"aDict at: 'test' put: 'testreplaced'; at: 'hello' put: 'hello'; at: 'hello2' {}put: 'hello2replaced'."
     string:='{hello}'.
     result:= FiconabGsub httpReplace: string using: aDict.
	self assert:  result='hello'.
	string:='{hello} hello2'.
	 result:= FiconabGsub httpReplace: string using: aDict.
	self assert: result='hello hello2'.
	
	
	! !

!FiconabGsubTests methodsFor: 'as yet unclassified' stamp: 'ScottSproule 1/2/2012 08:31'!
testJsonReplace

 | string result|
"aDict at: 'test' put: 'testreplaced'; at: 'hello' put: 'hello'; at: 'hello2' {}put: 'hello2replaced'."
'{"aps":{"alert":"testing push"},"aliases":["7923044488"]}'.
     string:='{"aps":{"alert":"testing {hello}"},"aliases":["{tsipid}"]}'.
     result:= FiconabGsub httpReplace: string using: aDict.
	self assert:  result='{"aps":{"alert":"testing hello"},"aliases":["7923044488"]}'..
	
	
	
	! !

TestCase subclass: #FiconabTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ficonab-Public-Tests'!

!FiconabTest methodsFor: 'as yet unclassified' stamp: 'ScottSproule 5/11/2012 17:36'!
testBasicEmail
	"comment stating purpose of message"

	|  msg f client creds |
	
	
	
	
	creds:=FiconabCredentials new.
	
	creds user: 'test'.
	creds password: '!!test123'.
	self assert: creds user='test'.
	
	f:=FiconabSES new.
	f credentials: creds.
      self assert: (f credentials user)=(creds user)	.
	msg:=Dictionary new.
	msg at: 'time' put: TimeStamp current printHttpFormat.
	msg at: 'data' put: Smalltalk systemInformationString withCRs.
	f host: 'localhost'.
	f port: 8083.
	client:= f send: 'scott.sproule@estormtech.com' using: 'testtemplate' with: msg.
      self assert:  client isSuccess.! !

!FiconabTest methodsFor: 'as yet unclassified' stamp: 'ScottSproule 5/11/2012 12:26'!
testCredentials

|aCreds|
   aCreds:=FiconabCredentials new.
   aCreds user: 'hello'.
   aCreds password: 'pass'.
   self assert: aCreds user='hello'.
   self assert: aCreds password='pass'.! !
